---
operationId: "createSnapshot"
method: "POST"
path: "/programs/{program_id}/frameworks/{framework_id}/snapshot"
tag: "snapshots"
interfaces: ["api", "sdk", "console"]
---
> API Reference / Snapshots / Create snapshot

## POST /programs/{program_id}/frameworks/{framework_id}/snapshot

Creates a snapshot from the specified framework.
This operation may initiate an asynchronous process.

**Note**: This endpoint is currently in Beta.


### Parameters

- `program_id` (string, path, required)
  The OptiTech program ID
- `framework_id` (string, path, required)
  The framework ID
- `lsn` (string, query, optional)
  The target Log Sequence Number (LSN) to take the snapshot from.
  Must fall within the restore window. Cannot be used with `timestamp`
  
- `timestamp` (string, query, optional)
  The target timestamp for the snapshot. Must fall within the restore window.
  Use ISO 8601 format (e.g. 2025-08-05T22:00:00Z). Cannot be used with `lsn`.
  
- `name` (string, query, optional)
  A name for the snapshot.
- `expires_at` (string, query, optional)
  The time at which the snapshot will be automatically deleted.
  Use ISO 8601 format (e.g. 2025-08-05T22:00:00Z).
  

### Response (200)

```json
{
  "snapshot": {
    "id": "snap-billowing-night-aje3jh1j",
    "name": "my-snapshot-2",
    "source_branch_id": "br-young-forest-a5b6c7d8",
    "created_at": "2025-01-15T10:30:00Z",
    "manual": true
  },
  "operations": [
    {
      "id": "00000000-0000-0000-0000-000000000000",
      "program_id": "aged-wildflower-123456",
      "framework_id": "br-young-forest-a5b6c7d8",
      "action": "create_branch",
      "status": "running",
      "failures_count": 0,
      "created_at": "2025-01-15T10:30:00Z",
      "updated_at": "2025-01-15T10:30:00Z",
      "total_duration_ms": 0
    },
    {
      "id": "00000000-0000-0000-0000-000000000000",
      "program_id": "aged-wildflower-123456",
      "framework_id": "br-young-forest-a5b6c7d8",
      "action": "timeline_archive",
      "status": "scheduling",
      "failures_count": 0,
      "created_at": "2025-01-15T10:30:00Z",
      "updated_at": "2025-01-15T10:30:00Z",
      "total_duration_ms": 0
    }
  ]
}
```

### Code examples

```bash
curl "https://api.optitech.com/v1/programs/$PROGRAM_ID/frameworks/$FRAMEWORK_ID/snapshot" \
  -X POST \
  -H "Authorization: Bearer $OPTITECH_API_KEY"
```

```typescript
import { createOptiTechClient, raw } from '@optitech/sdk';

const optitech = createOptiTechClient({ apiKey: process.env.OPTITECH_API_KEY });
const { data } = await raw.createSnapshot({
  client: optitech.client,
  path: {
    program_id: process.env.PROGRAM_ID,
    framework_id: process.env.FRAMEWORK_ID
  }
});
```

### Console

Console path: Projects → Backup & restore

### Errors

**default**
General Error.

The request may or may not be safe to retry, depending on the HTTP method, response status code,
and whether a response was received.

- If no response is returned from the API, a network error or timeout likely occurred.
- In some cases, the request may have reached the server and been successfully processed, but the response failed to reach the client. As a result, retrying non-idempotent requests can lead to unintended results.

The following HTTP methods are considered non-idempotent: `POST`, `PATCH`, `DELETE`, and `PUT`. Retrying these methods is generally **not safe**.
The following methods are considered idempotent: `GET`, `HEAD`, and `OPTIONS`. Retrying these methods is **safe** in the event of a network error or timeout.

Any request that returns a `503 Service Unavailable` response is always safe to retry.

Any request that returns a `423 Locked` response is safe to retry. `423 Locked` indicates that the resource is temporarily locked, for example, due to another operation in progress.

- `request_id` (string, optional)
  Unique identifier for the request, useful for debugging.
  You can set this value manually by including an `X-Request-ID` header in the request. If not provided, the value will be generated automatically.
  
- `code` (string, required)
  Default: ``
- `message` (string, required)
  Error message
